'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

exports.default = initGetElement;

var _appManagerError = require('./utils/app-manager-error');

var _appManagerError2 = _interopRequireDefault(_appManagerError);

var _config = require('./utils/config');

var _constants = require('./constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function initGetElement(slots, getElement, importTimeout) {
  return function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(slotName, fragmentName) {
      var errData, slot, querySelector, element;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              errData = {
                source: 'get_slot_element',
                fragment: fragmentName,
                slot: slotName
              };
              slot = slots[slotName];

              if (slot) {
                _context.next = 4;
                break;
              }

              throw new _appManagerError2.default('Slot ' + slotName + ' could not be found.', (0, _extends3.default)({}, errData, {
                level: _constants.levels.ERROR,
                code: 'slot_not_found',
                recoverable: false
              }));

            case 4:
              querySelector = slot.querySelector;

              if (querySelector) {
                _context.next = 7;
                break;
              }

              return _context.abrupt('return', null);

            case 7:
              _context.next = 9;
              return _promise2.default.race([getElement(querySelector), (0, _config.delay)(importTimeout)]);

            case 9:
              element = _context.sent;

              if (element) {
                _context.next = 12;
                break;
              }

              throw new _appManagerError2.default('Element ' + querySelector + ' not found for slot ' + slotName + '.', (0, _extends3.default)({}, errData, {
                level: _constants.levels.ERROR,
                code: 'element_not_found',
                recoverable: false
              }));

            case 12:
              return _context.abrupt('return', element);

            case 13:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function getSlotElement(_x, _x2) {
      return _ref.apply(this, arguments);
    }

    return getSlotElement;
  }();
}