'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _asyncGenerator2 = require('babel-runtime/helpers/asyncGenerator');

var _asyncGenerator3 = _interopRequireDefault(_asyncGenerator2);

exports.default = initCreateLifecycle;

var _appManagerError = require('./utils/app-manager-error');

var _appManagerError2 = _interopRequireDefault(_appManagerError);

var _constants = require('./constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var loadingStatusDetails = {
  level: _constants.levels.INFO,
  status: _constants.statuses.LOADING
};

var defaultStatusDetails = {
  level: _constants.levels.INFO,
  status: _constants.statuses.DEFAULT
};

function getErrorStatusDetails(amError) {
  return {
    level: amError.level || _constants.levels.ERROR,
    status: _constants.statuses.ERROR,
    message: amError.message
  };
}

function initCreateLifecycle(slots, getFragmentScript, getSlotElement, context) {
  return function () {
    var _ref = _asyncGenerator3.default.wrap( /*#__PURE__*/_regenerator2.default.mark(function _callee6(slotName, fragmentName, onError) {
      var getScript = function () {
        var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
          var getErrorMarkup, errorSlotElement;
          return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.prev = 0;
                  _context.next = 3;
                  return getFragmentScript(fragmentName);

                case 3:
                  return _context.abrupt('return', _context.sent);

                case 6:
                  _context.prev = 6;
                  _context.t0 = _context['catch'](0);
                  getErrorMarkup = slot.getErrorMarkup;

                  if (!(typeof getErrorMarkup === 'function')) {
                    _context.next = 24;
                    break;
                  }

                  _context.prev = 10;
                  _context.next = 13;
                  return getSlotElement(slotName, fragmentName);

                case 13:
                  errorSlotElement = _context.sent;

                  if (!errorSlotElement) {
                    _context.next = 18;
                    break;
                  }

                  _context.next = 17;
                  return getErrorMarkup(context.state);

                case 17:
                  errorSlotElement.innerHTML = _context.sent;

                case 18:
                  _context.next = 24;
                  break;

                case 20:
                  _context.prev = 20;
                  _context.t1 = _context['catch'](10);
                  _context.next = 24;
                  return onError(_context.t1);

                case 24:
                  _context.next = 26;
                  return onError(_context.t0);

                case 26:
                  throw _context.t0;

                case 27:
                case 'end':
                  return _context.stop();
              }
            }
          }, _callee, this, [[0, 6], [10, 20]]);
        }));

        return function getScript() {
          return _ref2.apply(this, arguments);
        };
      }();

      var updateStatus = function () {
        var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(statusDetails) {
          return _regenerator2.default.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  _context2.prev = 0;
                  _context2.next = 3;
                  return script.onUpdateStatus(statusDetails, context.state);

                case 3:
                  _context2.next = 9;
                  break;

                case 5:
                  _context2.prev = 5;
                  _context2.t0 = _context2['catch'](0);
                  _context2.next = 9;
                  return onError(_context2.t0);

                case 9:
                case 'end':
                  return _context2.stop();
              }
            }
          }, _callee2, this, [[0, 5]]);
        }));

        return function updateStatus(_x4) {
          return _ref3.apply(this, arguments);
        };
      }();

      var getLifecycleElement = function () {
        var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
          return _regenerator2.default.wrap(function _callee3$(_context3) {
            while (1) {
              switch (_context3.prev = _context3.next) {
                case 0:
                  _context3.prev = 0;
                  _context3.next = 3;
                  return getSlotElement(slotName, fragmentName);

                case 3:
                  return _context3.abrupt('return', _context3.sent);

                case 6:
                  _context3.prev = 6;
                  _context3.t0 = _context3['catch'](0);
                  _context3.next = 10;
                  return updateStatus(getErrorStatusDetails(_context3.t0));

                case 10:
                  throw _context3.t0;

                case 11:
                case 'end':
                  return _context3.stop();
              }
            }
          }, _callee3, this, [[0, 6]]);
        }));

        return function getLifecycleElement() {
          return _ref4.apply(this, arguments);
        };
      }();

      var unmount = function () {
        var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4() {
          var unmountSlotElement, amError;
          return _regenerator2.default.wrap(function _callee4$(_context4) {
            while (1) {
              switch (_context4.prev = _context4.next) {
                case 0:
                  _context4.next = 2;
                  return getLifecycleElement();

                case 2:
                  unmountSlotElement = _context4.sent;

                  if (!unmountSlotElement) {
                    _context4.next = 15;
                    break;
                  }

                  _context4.prev = 4;
                  _context4.next = 7;
                  return script.unmount(unmountSlotElement, context.state);

                case 7:
                  _context4.next = 15;
                  break;

                case 9:
                  _context4.prev = 9;
                  _context4.t0 = _context4['catch'](4);
                  amError = new _appManagerError2.default(_context4.t0, (0, _extends3.default)({}, errData, {
                    level: _constants.levels.ERROR,
                    code: 'unmount',
                    recoverable: true
                  }));
                  _context4.next = 14;
                  return updateStatus(getErrorStatusDetails(amError));

                case 14:
                  throw amError;

                case 15:
                case 'end':
                  return _context4.stop();
              }
            }
          }, _callee4, this, [[4, 9]]);
        }));

        return function unmount() {
          return _ref5.apply(this, arguments);
        };
      }();

      var handleError = function () {
        var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(err) {
          var getErrorMarkup, errorSlotElement;
          return _regenerator2.default.wrap(function _callee5$(_context5) {
            while (1) {
              switch (_context5.prev = _context5.next) {
                case 0:
                  _context5.prev = 0;
                  _context5.next = 3;
                  return updateStatus(getErrorStatusDetails(err));

                case 3:
                  _context5.next = 5;
                  return unmount();

                case 5:
                  _context5.next = 11;
                  break;

                case 7:
                  _context5.prev = 7;
                  _context5.t0 = _context5['catch'](0);
                  _context5.next = 11;
                  return onError(_context5.t0);

                case 11:
                  getErrorMarkup = slot.getErrorMarkup;

                  if (!(typeof getErrorMarkup === 'function')) {
                    _context5.next = 27;
                    break;
                  }

                  _context5.prev = 13;
                  _context5.next = 16;
                  return getLifecycleElement();

                case 16:
                  errorSlotElement = _context5.sent;

                  if (!errorSlotElement) {
                    _context5.next = 21;
                    break;
                  }

                  _context5.next = 20;
                  return getErrorMarkup(context.state);

                case 20:
                  errorSlotElement.innerHTML = _context5.sent;

                case 21:
                  _context5.next = 27;
                  break;

                case 23:
                  _context5.prev = 23;
                  _context5.t1 = _context5['catch'](13);
                  _context5.next = 27;
                  return onError(_context5.t1);

                case 27:
                case 'end':
                  return _context5.stop();
              }
            }
          }, _callee5, this, [[0, 7], [13, 23]]);
        }));

        return function handleError(_x5) {
          return _ref6.apply(this, arguments);
        };
      }();

      var errData, slot, script, mountSlotElement, amError, stop, _amError, getLoadingMarkup, errorSlotElement;

      return _regenerator2.default.wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              errData = {
                source: 'lifecycle',
                fragment: fragmentName,
                slot: slotName
              };
              slot = slots[slotName];
              _context6.next = 4;
              return _asyncGenerator3.default.await(getScript());

            case 4:
              script = _context6.sent;

              if (script) {
                _context6.next = 7;
                break;
              }

              return _context6.abrupt('return', false);

            case 7:
              _context6.next = 9;
              return _asyncGenerator3.default.await(updateStatus(loadingStatusDetails));

            case 9:
              _context6.next = 11;
              return _asyncGenerator3.default.await(getLifecycleElement());

            case 11:
              mountSlotElement = _context6.sent;

              if (!mountSlotElement) {
                _context6.next = 29;
                break;
              }

              _context6.prev = 13;

              if (!context.state.initialRender) {
                _context6.next = 19;
                break;
              }

              _context6.next = 17;
              return _asyncGenerator3.default.await(script.hydrate(mountSlotElement, context.state));

            case 17:
              _context6.next = 21;
              break;

            case 19:
              _context6.next = 21;
              return _asyncGenerator3.default.await(script.render(mountSlotElement, context.state));

            case 21:
              _context6.next = 29;
              break;

            case 23:
              _context6.prev = 23;
              _context6.t0 = _context6['catch'](13);
              amError = new _appManagerError2.default(_context6.t0, (0, _extends3.default)({}, errData, {
                level: _constants.levels.ERROR,
                code: 'mount',
                recoverable: true
              }));
              _context6.next = 28;
              return _asyncGenerator3.default.await(handleError(_context6.t0));

            case 28:
              throw amError;

            case 29:
              stop = void 0;

            case 30:
              if (stop) {
                _context6.next = 69;
                break;
              }

            case 31:
              if (!true) {
                _context6.next = 45;
                break;
              }

              _context6.prev = 32;
              _context6.next = 35;
              return true;

            case 35:
              stop = _context6.sent;
              return _context6.abrupt('break', 45);

            case 39:
              _context6.prev = 39;
              _context6.t1 = _context6['catch'](32);
              _context6.next = 43;
              return _asyncGenerator3.default.await(updateStatus(getErrorStatusDetails(_context6.t1)));

            case 43:
              _context6.next = 31;
              break;

            case 45:
              _context6.next = 47;
              return _asyncGenerator3.default.await(updateStatus(defaultStatusDetails));

            case 47:
              _context6.next = 49;
              return true;

            case 49:
              stop = _context6.sent;
              _context6.next = 52;
              return _asyncGenerator3.default.await(updateStatus(loadingStatusDetails));

            case 52:
              _context6.next = 54;
              return true;

            case 54:
              stop = _context6.sent;

              if (stop) {
                _context6.next = 67;
                break;
              }

              _context6.prev = 56;
              _context6.next = 59;
              return _asyncGenerator3.default.await(script.onStateChange(context.state));

            case 59:
              _context6.next = 67;
              break;

            case 61:
              _context6.prev = 61;
              _context6.t2 = _context6['catch'](56);
              _amError = new _appManagerError2.default(_context6.t2, (0, _extends3.default)({}, errData, {
                level: _constants.levels.ERROR,
                code: 'on_state_change',
                recoverable: true
              }));
              _context6.next = 66;
              return _asyncGenerator3.default.await(handleError(_context6.t2));

            case 66:
              throw _amError;

            case 67:
              _context6.next = 30;
              break;

            case 69:
              _context6.next = 71;
              return _asyncGenerator3.default.await(unmount());

            case 71:
              getLoadingMarkup = slot.getLoadingMarkup;

              if (!(typeof getLoadingMarkup === 'function')) {
                _context6.next = 87;
                break;
              }

              _context6.prev = 73;
              _context6.next = 76;
              return _asyncGenerator3.default.await(getLifecycleElement());

            case 76:
              errorSlotElement = _context6.sent;

              if (!errorSlotElement) {
                _context6.next = 81;
                break;
              }

              _context6.next = 80;
              return _asyncGenerator3.default.await(getLoadingMarkup(context.state));

            case 80:
              errorSlotElement.innerHTML = _context6.sent;

            case 81:
              _context6.next = 87;
              break;

            case 83:
              _context6.prev = 83;
              _context6.t3 = _context6['catch'](73);
              _context6.next = 87;
              return _asyncGenerator3.default.await(onError(_context6.t3));

            case 87:
              _context6.next = 89;
              return _asyncGenerator3.default.await(updateStatus(defaultStatusDetails));

            case 89:
              return _context6.abrupt('return', true);

            case 90:
            case 'end':
              return _context6.stop();
          }
        }
      }, _callee6, this, [[13, 23], [32, 39], [56, 61], [73, 83]]);
    }));

    function createLifecycle(_x, _x2, _x3) {
      return _ref.apply(this, arguments);
    }

    return createLifecycle;
  }();
}