'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _map = require('babel-runtime/core-js/map');

var _map2 = _interopRequireDefault(_map);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

exports.wrapScript = wrapScript;
exports.default = initGetFragmentScript;

var _appManagerError = require('./utils/app-manager-error');

var _appManagerError2 = _interopRequireDefault(_appManagerError);

var _config = require('./utils/config');

var _constants = require('./constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getV5State(state) {
  var _state$route = state.route,
      route = _state$route === undefined ? {} : _state$route,
      prevRoute = state.prevRoute;


  var app = {};

  if (route.fragment) {
    (0, _assign2.default)(app, { fragment: route.fragment });
  }

  if (route.fragments) {
    (0, _assign2.default)(app, { fragments: route.fragments });
  }

  if (route.path) {
    (0, _assign2.default)(app, { appPath: route.path });
  }

  if (route.paths) {
    (0, _assign2.default)(app, { appPaths: route.paths });
  }

  var prevApp = null;

  if (prevRoute) {
    prevApp = {};

    if (prevRoute.fragment) {
      (0, _assign2.default)(prevApp, { fragment: prevRoute.fragment });
    }

    if (prevRoute.fragments) {
      (0, _assign2.default)(prevApp, { fragments: prevRoute.fragments });
    }

    if (prevRoute.path) {
      (0, _assign2.default)(prevApp, { appPath: prevRoute.path });
    }

    if (prevRoute.paths) {
      (0, _assign2.default)(prevApp, { appPaths: prevRoute.paths });
    }
  }

  return {
    event: state.event,
    resource: state.resource,
    app: app,
    prevApp: prevApp
  };
}

function wrapScript(script) {
  return {
    hydrate: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(slotElement, state) {
        var v5State, _v5State;

        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.t0 = script.version;
                _context.next = _context.t0 === 4 ? 3 : _context.t0 === 5 ? 14 : _context.t0 === 6 ? 25 : 35;
                break;

              case 3:
                if (!state) {
                  _context.next = 13;
                  break;
                }

                v5State = getV5State(state);

                if (!(typeof script.hydrate === 'function')) {
                  _context.next = 10;
                  break;
                }

                _context.next = 8;
                return script.hydrate(slotElement, v5State.app);

              case 8:
                _context.next = 13;
                break;

              case 10:
                if (!(typeof script.mount === 'function')) {
                  _context.next = 13;
                  break;
                }

                _context.next = 13;
                return script.mount(slotElement, 'am-replaceState', v5State.app);

              case 13:
                return _context.abrupt('break', 36);

              case 14:
                if (!state) {
                  _context.next = 24;
                  break;
                }

                _v5State = getV5State(state);

                if (!(typeof script.hydrate === 'function')) {
                  _context.next = 21;
                  break;
                }

                _context.next = 19;
                return script.hydrate(slotElement, _v5State);

              case 19:
                _context.next = 24;
                break;

              case 21:
                if (!(typeof script.render === 'function')) {
                  _context.next = 24;
                  break;
                }

                _context.next = 24;
                return script.render(slotElement, _v5State);

              case 24:
                return _context.abrupt('break', 36);

              case 25:
                if (!state) {
                  _context.next = 34;
                  break;
                }

                if (!(typeof script.hydrate === 'function')) {
                  _context.next = 31;
                  break;
                }

                _context.next = 29;
                return script.hydrate(slotElement, state);

              case 29:
                _context.next = 34;
                break;

              case 31:
                if (!(typeof script.render === 'function')) {
                  _context.next = 34;
                  break;
                }

                _context.next = 34;
                return script.render(slotElement, state);

              case 34:
                return _context.abrupt('break', 36);

              case 35:
                throw new Error('Script has invalid version.');

              case 36:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function hydrate(_x, _x2) {
        return _ref.apply(this, arguments);
      }

      return hydrate;
    }(),
    render: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(slotElement, state) {
        var v5State, _v5State2;

        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.t0 = script.version;
                _context2.next = _context2.t0 === 4 ? 3 : _context2.t0 === 5 ? 9 : _context2.t0 === 6 ? 15 : 19;
                break;

              case 3:
                if (!state) {
                  _context2.next = 8;
                  break;
                }

                v5State = getV5State(state);

                if (!(typeof script.mount === 'function')) {
                  _context2.next = 8;
                  break;
                }

                _context2.next = 8;
                return script.mount(slotElement, state.event, v5State.app);

              case 8:
                return _context2.abrupt('break', 20);

              case 9:
                if (!state) {
                  _context2.next = 14;
                  break;
                }

                _v5State2 = getV5State(state);

                if (!(typeof script.render === 'function')) {
                  _context2.next = 14;
                  break;
                }

                _context2.next = 14;
                return script.render(slotElement, _v5State2);

              case 14:
                return _context2.abrupt('break', 20);

              case 15:
                if (!(state && typeof script.render === 'function')) {
                  _context2.next = 18;
                  break;
                }

                _context2.next = 18;
                return script.render(slotElement, state);

              case 18:
                return _context2.abrupt('break', 20);

              case 19:
                throw new Error('Script has invalid version.');

              case 20:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function render(_x3, _x4) {
        return _ref2.apply(this, arguments);
      }

      return render;
    }(),
    onStateChange: function () {
      var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(state) {
        var v5State, _v5State3;

        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.t0 = script.version;
                _context3.next = _context3.t0 === 4 ? 3 : _context3.t0 === 5 ? 9 : _context3.t0 === 6 ? 15 : 19;
                break;

              case 3:
                if (!state) {
                  _context3.next = 8;
                  break;
                }

                v5State = getV5State(state);

                if (!(typeof script.onStateChange === 'function')) {
                  _context3.next = 8;
                  break;
                }

                _context3.next = 8;
                return script.onStateChange(state.event, v5State.app);

              case 8:
                return _context3.abrupt('break', 20);

              case 9:
                if (!state) {
                  _context3.next = 14;
                  break;
                }

                _v5State3 = getV5State(state);

                if (!(typeof script.onStateChange === 'function')) {
                  _context3.next = 14;
                  break;
                }

                _context3.next = 14;
                return script.onStateChange(_v5State3);

              case 14:
                return _context3.abrupt('break', 20);

              case 15:
                if (!(state && typeof script.onStateChange === 'function')) {
                  _context3.next = 18;
                  break;
                }

                _context3.next = 18;
                return script.onStateChange(state);

              case 18:
                return _context3.abrupt('break', 20);

              case 19:
                throw new Error('Script has invalid version.');

              case 20:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function onStateChange(_x5) {
        return _ref3.apply(this, arguments);
      }

      return onStateChange;
    }(),
    unmount: function () {
      var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(slotElement, state) {
        var v5State, _v5State4;

        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.t0 = script.version;
                _context4.next = _context4.t0 === 4 ? 3 : _context4.t0 === 5 ? 9 : _context4.t0 === 6 ? 15 : 19;
                break;

              case 3:
                if (!state) {
                  _context4.next = 8;
                  break;
                }

                v5State = getV5State(state);

                if (!(typeof script.unmount === 'function')) {
                  _context4.next = 8;
                  break;
                }

                _context4.next = 8;
                return script.unmount(slotElement, state.event, v5State.prevApp);

              case 8:
                return _context4.abrupt('break', 20);

              case 9:
                if (!state) {
                  _context4.next = 14;
                  break;
                }

                _v5State4 = getV5State(state);

                if (!(typeof script.unmount === 'function')) {
                  _context4.next = 14;
                  break;
                }

                _context4.next = 14;
                return script.unmount(slotElement, _v5State4);

              case 14:
                return _context4.abrupt('break', 20);

              case 15:
                if (!(state && typeof script.unmount === 'function')) {
                  _context4.next = 18;
                  break;
                }

                _context4.next = 18;
                return script.unmount(slotElement, state);

              case 18:
                return _context4.abrupt('break', 20);

              case 19:
                throw new Error('Script has invalid version.');

              case 20:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function unmount(_x6, _x7) {
        return _ref4.apply(this, arguments);
      }

      return unmount;
    }(),
    onUpdateStatus: function () {
      var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(statusDetails, state) {
        var v5State, _v5State5;

        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.t0 = script.version;
                _context5.next = _context5.t0 === 4 ? 3 : _context5.t0 === 5 ? 9 : _context5.t0 === 6 ? 15 : 19;
                break;

              case 3:
                if (!state) {
                  _context5.next = 8;
                  break;
                }

                v5State = getV5State(state);

                if (!(typeof script.onUpdateStatus === 'function')) {
                  _context5.next = 8;
                  break;
                }

                _context5.next = 8;
                return script.onUpdateStatus(statusDetails.status, v5State.app);

              case 8:
                return _context5.abrupt('break', 20);

              case 9:
                if (!state) {
                  _context5.next = 14;
                  break;
                }

                _v5State5 = getV5State(state);

                if (!(typeof script.onUpdateStatus === 'function')) {
                  _context5.next = 14;
                  break;
                }

                _context5.next = 14;
                return script.onUpdateStatus(statusDetails, _v5State5);

              case 14:
                return _context5.abrupt('break', 20);

              case 15:
                if (!(state && typeof script.onUpdateStatus === 'function')) {
                  _context5.next = 18;
                  break;
                }

                _context5.next = 18;
                return script.onUpdateStatus(statusDetails, state);

              case 18:
                return _context5.abrupt('break', 20);

              case 19:
                throw new Error('Script has invalid version.');

              case 20:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function onUpdateStatus(_x8, _x9) {
        return _ref5.apply(this, arguments);
      }

      return onUpdateStatus;
    }()
  };
}

function initGetFragmentScript(fragments, importTimeout, context) {
  var cachedScripts = new _map2.default();

  return function () {
    var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6(fragmentName) {
      var cachedScript, errData, loadScript, wrappedScript, script, _ref7, _ref8;

      return _regenerator2.default.wrap(function _callee6$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              cachedScript = cachedScripts.get(fragmentName);

              if (!cachedScript) {
                _context6.next = 3;
                break;
              }

              return _context6.abrupt('return', cachedScript);

            case 3:
              errData = {
                source: 'load_script',
                fragment: fragmentName,
                slot: null
              };
              loadScript = fragments[fragmentName].loadScript;
              wrappedScript = null;

              if (!(typeof loadScript === 'function')) {
                _context6.next = 22;
                break;
              }

              script = void 0;
              _context6.prev = 8;
              _context6.next = 11;
              return _promise2.default.all([loadScript(context.state), (0, _config.delay)(importTimeout)]);

            case 11:
              _ref7 = _context6.sent;
              _ref8 = (0, _slicedToArray3.default)(_ref7, 1);
              script = _ref8[0];
              _context6.next = 19;
              break;

            case 16:
              _context6.prev = 16;
              _context6.t0 = _context6['catch'](8);
              throw new _appManagerError2.default(_context6.t0, (0, _extends3.default)({}, errData, {
                level: _constants.levels.ERROR,
                code: 'load_script',
                recoverable: true
              }));

            case 19:
              if (script) {
                _context6.next = 21;
                break;
              }

              throw new _appManagerError2.default('loadScript timed out for fragment ' + fragmentName + '.', (0, _extends3.default)({}, errData, {
                level: _constants.levels.ERROR,
                code: 'time_out',
                recoverable: true
              }));

            case 21:

              wrappedScript = wrapScript(script);

            case 22:

              cachedScripts.set(fragmentName, wrappedScript);
              return _context6.abrupt('return', wrappedScript);

            case 24:
            case 'end':
              return _context6.stop();
          }
        }
      }, _callee6, this, [[8, 16]]);
    }));

    function getFragmentScript(_x10) {
      return _ref6.apply(this, arguments);
    }

    return getFragmentScript;
  }();
}