'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _weakMap = require('babel-runtime/core-js/weak-map');

var _weakMap2 = _interopRequireDefault(_weakMap);

var _appManagerError = require('./app-manager-error');

var _appManagerError2 = _interopRequireDefault(_appManagerError);

var _constants = require('../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var errData = {
  source: 'context',
  slot: null,
  fragment: null
};

var stateContainer = new _weakMap2.default();

var Context = function () {
  function Context(initialState) {
    (0, _classCallCheck3.default)(this, Context);

    if (initialState) {
      this.setState(initialState);
    }
  }

  (0, _createClass3.default)(Context, [{
    key: 'setState',
    value: function setState(state) {
      if (!state) {
        throw new _appManagerError2.default('Attempted to set blank state.', (0, _extends3.default)({}, errData, {
          level: _constants.levels.ERROR,
          code: 'set_state',
          recoverable: true
        }));
      }

      stateContainer.set(this, state);

      return state;
    }
  }, {
    key: 'state',
    get: function get() {
      var state = stateContainer.get(this);

      if (!state) {
        throw new _appManagerError2.default('State has not been set.', (0, _extends3.default)({}, errData, {
          level: _constants.levels.ERROR,
          code: 'get_state',
          recoverable: true
        }));
      }

      return state;
    }
  }]);
  return Context;
}();

exports.default = Context;